function BarProfilerCreateProfile(ProfileName, CreatePosition)
	BarProfilerDebugPrint ("Create Profile function start, CreatePosition is")
	BarProfilerDebugPrint (CreatePosition)
	local key
	local value
	if BarProfilerDb.Realms[BarProfilerDb.CurrentRealm].Characters[BarProfilerDb.CurrentCharacter].Profiles[ProfileName] ~= nil then
		BarProfiler:Print ("Error - That Profile name is already being used")
		BarProfilerGui:Release(BarProfilerMainFrame)
		BarProfilerGuiMain()
		return 1
	end
	if CreatePosition == nil then
		table.insert (BarProfilerDb.Realms[BarProfilerDb.CurrentRealm].Characters[BarProfilerDb.CurrentCharacter].ProfileList, ProfileName)
		BarProfiler:Print("Profile", ProfileName, "created successfully")
	else
		table.insert (BarProfilerDb.Realms[BarProfilerDb.CurrentRealm].Characters[BarProfilerDb.CurrentCharacter].ProfileList, CreatePosition, ProfileName)
	end
	BarProfilerDb.Realms[BarProfilerDb.CurrentRealm].Characters[BarProfilerDb.CurrentCharacter].Profiles[ProfileName] = {}
	for CreateSlotsLoop = 1, 120 do
		BarProfilerDb.Realms[BarProfilerDb.CurrentRealm].Characters[BarProfilerDb.CurrentCharacter].Profiles[ProfileName][CreateSlotsLoop] = {}
	end
	BarProfilerGui:Release(BarProfilerMainFrame)
	BarProfilerGuiMain()
	BarProfilerDebugPrint ("Create Profile function Done")
end
function BarProfilerDeleteProfile(PrintCheck)
	BarProfilerDebugPrint ("Delete Profile Start")
	local DeleteName = BarProfilerDb.Realms[BarProfilerDb.CurrentRealm].Characters[BarProfilerDb.CurrentCharacter].ProfileList[BarProfilerDb.SelectedProfile]
	BarProfilerDb.Realms[BarProfilerDb.CurrentRealm].Characters[BarProfilerDb.CurrentCharacter].Profiles[DeleteName] = nil	
	table.remove(BarProfilerDb.Realms[BarProfilerDb.CurrentRealm].Characters[BarProfilerDb.CurrentCharacter].ProfileList, BarProfilerDb.SelectedProfile)
	if PrintCheck == nil then
		BarProfiler:Print ("Profile", DeleteName, "deleted successfully")
	end
	BarProfilerGui:Release(BarProfilerMainFrame)
	BarProfilerGuiMain()
	BarProfilerDebugPrint ("DeleteProfile Done")
end
function BarProfilerRenameProfile(NewProfileName)
	BarProfilerDebugPrint("Rename Profile function Start")
	local CreatePosition = BarProfilerDb.SelectedProfile + 1
	local error = BarProfilerCreateProfile (NewProfileName, CreatePosition)
	if error == 1 then
		BarProfilerDebugPrint ("ProfileName already taken, return to previous")
		BarProfilerGui:Release(BarProfilerMainFrame)
		BarProfilerGuiMain()
		return
	end
	local OldProfileName = BarProfilerDb.Realms[BarProfilerDb.CurrentRealm].Characters[BarProfilerDb.CurrentCharacter].ProfileList[BarProfilerDb.SelectedProfile]
	BarProfilerDebugPrint("Old ProfileName was")
	BarProfilerDebugPrint (OldProfileName)
	BarProfilerDb.Realms[BarProfilerDb.CurrentRealm].Characters[BarProfilerDb.CurrentCharacter].Profiles[NewProfileName] = BarProfilerDb.Realms[BarProfilerDb.CurrentRealm].Characters[BarProfilerDb.CurrentCharacter].Profiles[OldProfileName]
	BarProfilerDeleteProfile(1)
	BarProfilerDb.Realms[BarProfilerDb.CurrentRealm].Characters[BarProfilerDb.CurrentCharacter].Profiles[NewProfileName].DataCheck = 1
	BarProfilerDebugPrint("Rename Profile function Done")
	BarProfiler:Print ("Profile", OldProfileName, "renamed to", NewProfileName)
end