function BarProfilerGuiMain()
	BarProfilerDebugPrint("Gui Main function start")
	
	BarProfilerMainFrame = BarProfilerGui:Create("Window")
		BarProfilerMainFrame:SetTitle("Bar Profiler")
		BarProfilerMainFrame:EnableResize(Hide)
		BarProfilerMainFrame:SetWidth(230)
		BarProfilerMainFrame:SetHeight(270)
		BarProfilerMainFrame:SetCallback("OnClose",	function(widget) BarProfilerGuiMainCloseHandler(widget) end)
		BarProfilerMainFrame:SetLayout("List")
		
	BarProfilerNewProfileEditBox = BarProfilerGui:Create("EditBox")
		BarProfilerNewProfileEditBox:SetLabel("Enter a name to create a new Profile:")
		BarProfilerNewProfileEditBox:SetWidth(200)
		BarProfilerNewProfileEditBox:SetCallback("OnEnterPressed", 	function(widget, event, ProfileName) BarProfilerCreateProfile(ProfileName) end)
		BarProfilerMainFrame:AddChild(BarProfilerNewProfileEditBox)
		
	BarProfilerlist = BarProfilerGui:Create("Dropdown")
		BarProfilerlist:SetText("Profiles")
		BarProfilerlist:SetList(BarProfilerDb.Realms[BarProfilerDb.CurrentRealm].Characters[BarProfilerDb.CurrentCharacter].ProfileList)
		BarProfilerlist:SetCallback("OnValueChanged", function(widget, event, key) BarProfilerDb.SelectedProfile=BarProfileListHandler(key) end)
		BarProfilerMainFrame:AddChild(BarProfilerlist)
		
	BarProfilerDeleteButton = BarProfilerGui:Create("Button")
		BarProfilerDeleteButton:SetText("Delete Profile")
		BarProfilerDeleteButton:SetCallback("OnClick", 	function(widget) BarProfilerConfirmationWindow("Caution: This profile and the action bars saved under it will be lost. Are you sure you wish to continue?", "DeleteProfile") end)
		BarProfilerMainFrame:AddChild(BarProfilerDeleteButton)
		BarProfilerDeleteButton:SetDisabled(1)
		
	BarProfilerSaveButton = BarProfilerGui:Create("Button")
		BarProfilerSaveButton:SetText("Save Bars to Profile")
		BarProfilerSaveButton:SetCallback("OnClick", 	function(widget) BarProfilerConfirmationWindow("Caution: The current action bar data for this profile will be lost. Are you sure you wish to continue?", "SaveBars") end)
		BarProfilerMainFrame:AddChild(BarProfilerSaveButton)
		BarProfilerSaveButton:SetDisabled(1)
		
		
	BarProfilerLoadButton = BarProfilerGui:Create("Button")
		BarProfilerLoadButton:SetText("Load Bars from Profile")
		BarProfilerLoadButton:SetCallback("OnClick", 	function(widget) BarProfilerConfirmationWindow("Caution: Loading a profile will re-arrange all of your current action bars. It is advised you save your current action bars before doing this. Are you sure you wish to continue?", "LoadBars") end)
		BarProfilerMainFrame:AddChild(BarProfilerLoadButton)	
		BarProfilerLoadButton:SetDisabled(1)
		
	BarProfilerRenameProfileEditBox = BarProfilerGui:Create("EditBox")
		BarProfilerRenameProfileEditBox:SetLabel("Enter a name to rename the profile")
		BarProfilerRenameProfileEditBox:SetCallback("OnEnterPressed", 	function(widget, event, NewProfileName) BarProfilerRenameProfile(NewProfileName) end)
		BarProfilerMainFrame:AddChild(BarProfilerRenameProfileEditBox)		
		BarProfilerRenameProfileEditBox:SetDisabled(1)
	BarProfilerDebugPrint("Gui Main function Done")
end
function BarProfilerGuiMainCloseHandler(widget)
	BarProfilerDebugPrint("Gui Close Handler function start")
	BarProfilerGui:Release(widget)
	BarProfilerSlashCount = 0
	BarProfilerDebugPrint("Gui Close Handler function done")
end
function BarProfileListHandler(key)
	BarProfilerDebugPrint("List Handler function start")
	BarProfilerDeleteButton:SetDisabled(nil)
	BarProfilerLoadButton:SetDisabled(nil)
	BarProfilerSaveButton:SetDisabled(nil)
	BarProfilerRenameProfileEditBox:SetDisabled(nil)
	BarProfilerDebugPrint("List Handler function Done, Key is")
	BarProfilerDebugPrint (key)
	return key
end
function BarProfilerConfirmationWindow(PrintString, Destination)
	local ProfileName = BarProfilerDb.Realms[BarProfilerDb.CurrentRealm].Characters[BarProfilerDb.CurrentCharacter].ProfileList[BarProfilerDb.SelectedProfile]
	if Destination == "LoadBars" then
		if BarProfilerDb.Realms[BarProfilerDb.CurrentRealm].Characters[BarProfilerDb.CurrentCharacter].Profiles[ProfileName].DataCheck == nil then
			BarProfiler:Print ("Error - There is no data to load")
			return
		end
	elseif Destination == "SaveBars" then
		if BarProfilerDb.Realms[BarProfilerDb.CurrentRealm].Characters[BarProfilerDb.CurrentCharacter].Profiles[ProfileName].DataCheck == nil then
			BarProfilerSaveBars()
			return
		end
	end

	BarProfilerMainLockToggle(1)

	BarProfilerMessageFrame = BarProfilerGui:Create("Window")
		BarProfilerMessageFrame:EnableResize(Hide)
		BarProfilerMessageFrame:SetWidth(520)
		BarProfilerMessageFrame:SetHeight(200)
		BarProfilerMessageFrame:SetTitle("Confirmation Needed")
		BarProfilerMessageFrame:SetLayout("Flow")
		BarProfilerMessageFrame:SetCallback("OnClose", 	function(widget) BarProfilerGuiMainCloseHandler(widget) end)
	
	local BarProfilerMessageFrameTop = BarProfilerGui:Create("InlineGroup")
		BarProfilerMessageFrameTop:SetWidth(500)
		BarProfilerMessageFrameTop:SetLayout("Fill")
		BarProfilerMessageFrame:AddChild(BarProfilerMessageFrameTop)
		
	local BarProfilerMessage = BarProfilerGui:Create("Label")
		BarProfilerMessage:SetWidth(500)
		BarProfilerMessage:SetText (PrintString)
		BarProfilerMessage:SetFont ("Fonts\\FRIZQT__.TTF", 15)
		BarProfilerMessageFrameTop:AddChild(BarProfilerMessage)
		
	local BarProfilerMessageYesButton = BarProfilerGui:Create("Button")
		BarProfilerMessageYesButton:SetWidth(245)
		BarProfilerMessageYesButton:SetText ("Yes")
		BarProfilerMessageYesButton:SetCallback("OnClick", 	function(widget) BarProfilerConfirmationWindowYesHandler(Destination, Data) end)
		BarProfilerMessageFrame:AddChild(BarProfilerMessageYesButton)

	local BarProfilerMessageNoButton = BarProfilerGui:Create("Button")
		BarProfilerMessageNoButton:SetWidth(245)
		BarProfilerMessageNoButton:SetText ("No")
		BarProfilerMessageNoButton:SetCallback("OnClick", 	function(widget) BarProfilerConfirmationWindowNoHandler() end)
		BarProfilerMessageFrame:AddChild(BarProfilerMessageNoButton)
end
function BarProfilerConfirmationWindowYesHandler(Destination)
	BarProfilerMainLockToggle(nil)
	BarProfilerGui:Release(BarProfilerMessageFrame)
	if Destination == "DeleteProfile" then
		BarProfilerDeleteProfile()
	elseif Destination == "SaveBars" then
		BarProfilerSaveBars()
	elseif Destination == "LoadBars" then
		BarProfilerLoadBars()
	end
end
function BarProfilerConfirmationWindowNoHandler()
	BarProfilerMainLockToggle(nil)
	BarProfilerGui:Release(BarProfilerMessageFrame)
end
function BarProfilerMainLockToggle(Value)
	BarProfilerNewProfileEditBox:SetDisabled(Value)
	BarProfilerlist:SetDisabled(Value)
	BarProfilerDeleteButton:SetDisabled(Value)
	BarProfilerLoadButton:SetDisabled(Value)
	BarProfilerSaveButton:SetDisabled(Value)
	BarProfilerRenameProfileEditBox:SetDisabled(Value)
end